local original = PlayerStandard._do_melee_damage

function PlayerStandard:_do_melee_damage(t, bayonet_melee, melee_hit_ray, melee_entry, hand_id)
	melee_entry = melee_entry or managers.blackmarket:equipped_melee_weapon()
	local hit = original(self, t, bayonet_melee, melee_hit_ray, melee_entry, hand_id)
	if (bayonet_melee) then return hit end
	if (melee_entry ~= "model24") then return hit end

	local sphere_cast_radius = 20
	local col_ray = nil

	if melee_hit_ray then
		col_ray = melee_hit_ray ~= true and melee_hit_ray or nil
	else
		col_ray = self:_calc_melee_hit_ray(t, sphere_cast_radius)
	end

	if col_ray then
		local tweak_entry = tweak_data.projectiles["frag"]
		local effect_params = {sound_event = "grenade_explode",
			effect = "effects/payday2/particles/explosions/grenade_explosion",
			feedback_range = tweak_entry.range * 2,
			camera_shake_max_mul = 4
		}
		if managers and managers.explosion then
			local normal = math.UP
			local slot_mask = managers.slot:get_mask("explosion_targets")
			local damage_params = {
				player_damage = 0,
				curve_pow = 3,
				no_raycast_check_characters = false,
				hit_pos = col_ray.hit_position,
				range = tweak_entry.range,
				collision_slotmask = slot_mask,
				damage = tweak_entry.damage
			}
			
			local network_damage = math.ceil(tweak_entry.damage * 163.84)

			managers.explosion:give_local_player_dmg(col_ray.hit_position, tweak_entry.range, tweak_entry.player_damage)
			managers.explosion:play_sound_and_effects(col_ray.hit_position, normal, tweak_entry.range, effect_params)
			managers.explosion:detect_and_give_dmg(damage_params)
			
			managers.network:session():send_to_peers_synched("sync_explode_bullet", col_ray.hit_position, normal, math.min(16384, network_damage), managers.network:session():local_peer():id())
		end
	end
	return hit
end

-- {
--      		"hook_id": "lib/network/matchmaking/networkmatchmakingsteam",
--      		"script_path": "lock_to_singleplayer.lua"
--    	}